package cn.reghao.tnb.content.app.geo.util;

/***
 * wgs84 84年提出，大地坐标，也是原始坐标。
 * gcj02 02年提出，火星坐标，经过加密算法。大多数非百度中国地图厂商基本都是使用的火星坐标：高德，腾讯，谷歌中国cn
 * bd09  09年提出，百度坐标，经过火星坐标再次加密，相当于对大地坐标经过了二次加密。百度自己使用
 * 一般的算法，没有直接bd09->wgs84或者wgs84->bd09，都需要借助wgs84->gcj02或者gcj02->wgs84算法推导。
 */
public class GpsTransfer {
    //π的定义
    public static double pi = 3.1415926535897932384626;
    //椭球长半径，依据克拉索索夫斯基椭球系数计算
    public static double a = 6378245.0;
    //第一偏心率的平方
    public static double ee = 0.00669342162296594323;

    public static double transformLat(double x, double y) {
        double ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y
                + 0.2 * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * pi) + 20.0 * Math.sin(2.0 * x * pi)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(y * pi) + 40.0 * Math.sin(y / 3.0 * pi)) * 2.0 / 3.0;
        ret += (160.0 * Math.sin(y / 12.0 * pi) + 320 * Math.sin(y * pi / 30.0)) * 2.0 / 3.0;
        return ret;
    }

    public static double transformLng(double x, double y) {
        double ret = 300.0 + x + 2.0 * y + 0.1 * x * x + 0.1 * x * y + 0.1
                * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * pi) + 20.0 * Math.sin(2.0 * x * pi)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(x * pi) + 40.0 * Math.sin(x / 3.0 * pi)) * 2.0 / 3.0;
        ret += (150.0 * Math.sin(x / 12.0 * pi) + 300.0 * Math.sin(x / 30.0
                * pi)) * 2.0 / 3.0;
        return ret;
    }

    /***
     * 判断是否在中国范围之内
     * @param lat
     * @param lng
     * @return
     */
    public static boolean outOfChina(double lat, double lng) {
        if (lng < 72.004 || lng > 137.8347)
            return true;
        if (lat < 0.8293 || lat > 55.8271)
            return true;
        return false;
    }

    /***
     * 把公式部分抽取出来
     * @param lat
     * @param lng
     * @return
     */
    public static Gps transform(double lat, double lng) {
        if (outOfChina(lat, lng)) {
            return new Gps(lat, lng);
        }
        double dLat = transformLat(lng - 105.0, lat - 35.0);
        double dLng = transformLng(lng - 105.0, lat - 35.0);
        double radLat = lat / 180.0 * pi;
        double magic = Math.sin(radLat);
        magic = 1 - ee * magic * magic;
        double sqrtMagic = Math.sqrt(magic);
        dLat = (dLat * 180.0) / ((a * (1 - ee)) / (magic * sqrtMagic) * pi);
        dLng = (dLng * 180.0) / (a / sqrtMagic * Math.cos(radLat) * pi);
        double mgLat = lat + dLat;
        double mgLng = lng + dLng;
        return new Gps(mgLat, mgLng);
    }

    /***
     * wgs84到gcj02转换
     * @param lat
     * @param lng
     * @return
     */
    public static Gps wgs84_To_Gcj02(double lat, double lng) {
        return transform(lat, lng);
    }

    /***
     * 简单的gcj02到wgs84坐标类型转换，只做了一次迭代
     */
    public static Gps gcj02_To_Wgs84(double lat, double lng) {
        Gps gps = transform(lat, lng);
        double lngtitude = lng * 2 - gps.lng;
        double latitude = lat * 2 - gps.lat;
        return new Gps(latitude, lngtitude);
    }

    /***
     * 稍微精确一点的gcj02到wgs84转换
     * @param lat
     * @param lng
     * @return
     */
    public static Gps gcj02_To_Wgs84_exact(double lat,double lng) {
        if (outOfChina(lat, lng)) {
            return gcj02_To_Wgs84(lat, lng);
        }
        double initDelta = 0.01;
        double threshold = 0.000001;
        double dLat = initDelta;
        double dLng = initDelta;
        double mLat = lat - dLat;
        double mLng = lng - dLng;
        double pLat = lat + dLat;
        double pLng = lng + dLng;
        double wgsLat = 0;
        double wgsLng = 0;
        int i = 0;
        while (true) {
            wgsLat = (mLat + pLat) / 2;
            wgsLng = (mLng + pLng) / 2;
            Gps tmp = wgs84_To_Gcj02(wgsLat, wgsLng);
            dLat = tmp.lat - lat;
            dLng = tmp.lng - lng;
            if ((Math.abs(dLat) < threshold) && (Math.abs(dLng) < threshold)) {
                break;
            }
            if (dLat > 0) { pLat = wgsLat; } else { mLat = wgsLat;}
            if (dLng > 0) { pLng = wgsLng; } else { mLng = wgsLng;}

            if (++i > 1000) break;
        }

        return new Gps(wgsLat, wgsLng);
    }

    /***
     * 百度坐标是在火星坐标基础上做的二次加密
     * @param gg_lat
     * @param gg_lng
     * @return
     */
    public static Gps gcj02_To_Bd09(double gg_lat, double gg_lng) {
        double x = gg_lng, y = gg_lat;
        double z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * pi);
        double theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * pi);
        double bd_lng = z * Math.cos(theta) + 0.0065;
        double bd_lat = z * Math.sin(theta) + 0.006;
        return new Gps(bd_lat, bd_lng);
    }

    /***
     * 百度坐标与火星坐标逆向转换
     * @param bd_lat
     * @param bd_lng
     * @return
     */
    public static Gps bd09_To_Gcj02(double bd_lat, double bd_lng) {
        double x = bd_lng - 0.0065, y = bd_lat - 0.006;
        double z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * pi);
        double theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * pi);
        double gg_lng = z * Math.cos(theta);
        double gg_lat = z * Math.sin(theta);
        return new Gps(gg_lat, gg_lng);
    }

    public static void main(String[] args) {
        Gps gps1 = new Gps(39.9072885060602, 116.39123343289631);
        Gps gps = new Gps(33.41499708333333, 102.34823608333333);

        System.out.println(gps);//{39.9072885060602,116.39123343289631}
        Gps gps2 = wgs84_To_Gcj02(gps.lat, gps.lng);
        System.out.println(gps2);//{39.9086897410389,116.39747455259267}
        Gps gps3 = gcj02_To_Wgs84(gps2.lat, gps2.lng);
        System.out.println(gps3);//{39.907286247736586,116.39123098626051}
        Gps gps4 = gcj02_To_Wgs84_exact(gps2.lat, gps2.lng);
        System.out.println(gps4);//{39.907288984202964,116.3912337078661} 相对一次迭代是精确了，但是好像也不是完全还原
    }
}
